
package FortranHandler;

#
# Object: FortranHandler
#
#
# Instance variables:
#
#
# Methods
#

@ISA = qw(DocumentHandler);

grep($stoplist{$_}++,
     qw(to in on around over under the a an is this be of if or its and by
	as ));

#
# Create a new handler for the current walker process.
#
sub new
{
    my($class, $mdb) = @_;
    my $self = {};
    bless $self;
    $$self{'OBJ_config_file_entries'} = {};

    $self->generate_accessors('mdb');

    $self->set_mdb($mdb);

    print "FortranHandler created $self\n";
    return $self;
}

#
# Check to see if the retrieved url is an image
#
sub got_image
{
    my($self, $suffix, $content_type) = @_;

    return 0;
}

# 
# Check to see if the retrieved url is an audio file
#
sub got_sound
{
    my($self, $suffix) = @_;

    return 0;
}

#
# Check suffix on current url to see if this handler should be used.
#
sub accepts_suffix
{
    my($self, $suffix) = @_;

    return (($suffix eq 'f') || ($suffix eq 'fm'));
}

#
# Check content of Web page to see if this handler should be used.
#
sub accepts_content
{
    my($self, $content) = @_;
    my(@lines, $l, $possible);

    $possible = 0;
    @lines = split(/\n/, $content);

    for $l (@lines)
    {
	if ($possible == 0)
	{
            if ($l =~ /^\s*program/i)
	    {
	       $possible = 1;
            }
        }
	else
	{
	    if ($l =~ /^\s*end/i)
	    {
		return 1;
            }
        }
    }
    return 0;
}

# 
# Check content type of Web page to see if this handler should be used.
#
sub accepts
{
    my($self, $content_type) = @_;
	
    return 0;
}

#
# Mark url as a Fortran file.
#
sub handle
{
    my($self, $url, $content_glob, $headers_glob) = @_;

    print "Handling Fortran $url\n";

    Nexus::rpc_async($self->mdb(), "add_type", $url->as_string, "Fortran");

    return;
}
     
1;
