
package IndexingHandler;

#
# Object: IndexingHandler
#
#
# Instance variables:
#
#
# Methods
#

@ISA = qw(DocumentHandler);

grep($stoplist{$_}++,
     qw(to in on around over under the a an is this be of if or its and by
	as ));

#
# Create a new handler for the current walker process.
#
sub new
{
    my($class, $mdb) = @_;
    my $self = {};
    bless $self;
    my $engine_gp;
    
    if ($::indexing_engine)
    {
	print "Indexing handler connecting to $::indexing_engine\n";
	$engine_gp = Nexus::attach($::indexing_engine);
	if (!$engine_gp)
	{
	    if ($::require_indexing)
	    {
		die "Cannot connect to indexing engine at $::indexing_engine.\n";
	    }
	    else
	    {
		warn "Cannot connect to indexing engine at $::indexing_engine. Not indexing.\n";
		return undef;
	    }
	}
	    
    }

    $$self{'OBJ_config_file_entries'} = {};

    $self->generate_accessors('mdb', 'engine_gp');

    $self->set_mdb($mdb);
    $self->set_engine_gp($engine_gp);
    
    print "IndexingHandler created $self\n";

    return $self;
}

# 
# Check content type of Web page to see if this handler should be used.
#
sub accepts
{
    my($self, $content_type) = @_;

    if ($content_type =~ m,^text/,)
    {
	return 1;
    }
    else
    {
	return 0;
    }
}

#
# Give the page to the indexing engine.
#
sub handle
{
    my($self, $url, $content_glob, $headers_glob, $loc) = @_;
    my($rc);
    local(@links, @labs, @lorig, @ltype, *headers, *content);
    my(%mlinks, $raw_content, $words, @h);
    my($l);

#    print "Indexing $url\n";

#    *content = $content_glob;

#    print "content is $content\n";

#    $raw_content = $content;

    #
    # Nah, let's not deal with this right now.
    # $words = $self->extract_content($raw_content);

    Nexus::rpc_async($self->engine_gp(), "index", $url->as_string(), $loc);
}

#
# Remove content from Web page.
#
sub extract_content
{
    my($self, $content) = @_;
    my($word, %words, $rc);

    $content =~ s/\s+/ /g;    

    # Remove all of the formatting
    
    $content =~ s#<[^<]+>##g;

    # Remove punctuation

    $content =~ s/[^a-zA-Z\s]//g;

    # Create unique word list

    for $word (split(/\s+/, $content))
    {
	$word = "\L$word";
	next if $stoplist{$word};
	$words{$word}++;
    }
    
    for $word (sort {$words{$b} <=> $words{$a}} keys %words)
    {
	$rc .= "$word $words{$word}\n";
    }
    return $rc;
}
     
1;
