
package TarHandler;

#
# Object: TarHandler
#
#
# Instance variables:
#
#
# Methods
#

@ISA = qw(DocumentHandler);

grep($stoplist{$_}++,
     qw(to in on around over under the a an is this be of if or its and by
	as ));

#
# Create a new handler for the current walker process.
#
sub new
{
    my($class, $mdb, $walker) = @_;
    my $self = {};
    bless $self;
    $$self{'OBJ_config_file_entries'} = {};

    $self->generate_accessors('mdb');
    $self->generate_accessors('walker');

    $self->set_mdb($mdb);
    $self->set_walker($walker);

    print "TarHandler created $self\n";
    return $self;
}

#
# Check to see if the retrieved url is an image
#
sub got_image
{
    my($self, $suffix, $content_type) = @_;

    return 0;
}

# 
# Check to see if the retrieved url is an audio file
#
sub got_sound
{
    my($self, $suffix) = @_;

    return 0;
}

#
# Check suffix on current url to see if this handler should be used.
#
sub accepts_suffix
{
    my($self, $suffix) = @_;

    return $suffix eq 'tar';
}

#
# Check content of Web page to see if this handler should be used.
#
sub accepts_content
{
    my($self, $content) = @_;

    return 0;
}

# 
# Check content type of Web page to see if this handler should be used.
#
sub accepts
{
    my($self, $content_type) = @_;

    if ($content_type =~ /tar/)
    {
	return 1;
    }
    else
    {
        return 0; 
    }
}

#
# Untar the file.
#
sub handle
{
    my($self, $url, $content_glob, $headers_glob) = @_;
    my($data, $index, $new_url);
    local(*content, *headers);

    print "Handling Tar $url\n";

    *content = $content_glob;
    %headers = '';
    Nexus::rpc_async($self->mdb(), "add_type", $url->as_string, "Tar");

    $index = 0;
    while ($index < length($content))
    {
        $l = length($content);	
	$index = &read_file($content, \$name, \$data, $index);
	if ($index > 0)
	{
            $new = "$url#$name"; 
            $new_url = new URI::URL $new; 
	    Nexus::rpc_async($self->mdb(), "new_url", $new_url->as_string,
			      $url->as_string);
            $self->walker->get_handler($new_url, %headers, $data);	
        }
	else
	{
	    $index = $l;
        }
    }
    return;
}

#
# Read the files from the tar file.
#
sub read_file
{
    my($content, $name, $data, $index) = @_;
    my($str);
    my($mode, $uid, $gid, $size, $mtime, $chksum, $linkflag, $linkname);
    my($TBLOCK, $NAMSIZ);

    $TBLOCK = 512;
    $NAMSIZ = 100;

    $$data = '';
    $str = substr($content, $index, $TBLOCK);
    $index += $TBLOCK;

    if (substr($str, 0, 1) eq "\0")
    {
	return 0;
    }

    ($$name, $mode, $uid, $gid, $size, $mtime, $chksum, $linkflag, $linkname) =
	    unpack("A$NAMSIZ A8 A8 A8 A12 A12 A8 A1 A$NAMSIZ", $str);

    $size = oct($size);

    while ($size > 0)
    {
	$str = substr($content, $index, $TBLOCK);
	$index += $TBLOCK;
	if ($size > $TBLOCK)
	{
	    $$data .= $str;
        }
	else
	{
	    $$data .= substr($str, 0, $size);
        }
	$size -= $TBLOCK;
    }
    return ($index);
}

1;
